package com.zipcoder.payment;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class PaymentPresenterTest {

    @Test
    void toStringTest() {
        Payment[] payments = new Payment[0];
        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "";

        String actual = presenter.toString(payments);

        assertEquals(expected, actual);
    }

    @Test
    void toStringTest2() {
        Payment paypal = new PayPal(4L, "Tia Mowry", "tia@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");
        Payment[] payments = new Payment[]{paypal, check};

        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "Check Tia Mowry ***4551\nPayPal Tia Mowry tia@mowry.com\n";

        String actual = presenter.toString(payments);
        assertEquals(expected, actual);
    }

    @Test
    void toStringByPayerNameTest() {
        Payment paypal = new PayPal(4L, "Tamara Mowry", "tamara@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");
        Payment[] payments = new Payment[]{check, paypal};

        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "PayPal Tamara Mowry tamara@mowry.com\nCheck Tia Mowry ***4551\n";

        String actual = presenter.toStringByPayerName(payments);
        assertEquals(expected, actual);
    }

    @Test
    void toStringByIdTest() {
        Payment paypal = new PayPal(120L, "Tamara Mowry", "tamara@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");
        Payment[] payments = new Payment[]{paypal, check};


        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "Check Tia Mowry ***4551\nPayPal Tamara Mowry tamara@mowry.com\n";

        String actual = presenter.toStringById(payments);
        assertEquals(expected, actual);

    }
}